
local WM = WINDOW_MANAGER
local RMM_RET = ZO_ReticleContainerReticle
local rmm_buffer_table = {}

rmm_name = "RiveMouseMod"
rmm_cormmand = "/rmm"
rmm_version = 0.03
rmm_saved_data = "rmm_saved"
rmm_defaults = {}
rmm_data = {}

rmm_defaults = {
	AddonEnabled = true,
	ReticleColor = {r=1, g=1, b=1},
	ReticleSize = 1.25,
	CombatReticleEnabled = true,
	CombatReticleColor = {r=1, g=0, b=0},
	AutoSheathe = true,
	WeaponDrawn = false,
	Cursor = {
		Enabled = true,
		FreeLook = true,
	}
}

rmm_mousekey = 0
function RMM_MouseDown(eventCode, button, ctrl, alt, _shift, command)
	rmm_mousekey = button
end

function RMM_RightClickFreeLook()
	if rmm_mousekey == 2 then
		rmm_data.Cursor.FreeLook = true
	else
		rmm_data.Cursor.FreeLook = false
	end
end

function RMM_WeaponSheathe()
	if rmm_data.WeaponDrawn == true then
		if IsUnitInCombat("player") == false then
			TogglePlayerWield()
			rmm_data.WeaponDrawn = false
		end
	end
end

function RMM_ToggleEnabled()
	if rmm_data.AddonEnabled == true then
		rmm_data.AddonEnabled = false
		RMM_RET:SetColor(1,1,1)
		d("Disabled " .. rmm_name)
	else
		rmm_data.AddonEnabled = true
		RMM_RET:SetColor(rmm_data.ReticleColor.r,rmm_data.ReticleColor.g,rmm_data.ReticleColor.b)
		d("Enabled " .. rmm_name)
	end
end

function RMM_ToggleAutoMouse()
	if rmm_data.Cursor.Enabled == true then
		rmm_data.Cursor.Enabled = false
		d("Disabled " .. rmm_name .. " auto mouse")
	else
		rmm_data.Cursor.Enabled = true
		d("Enabled " .. rmm_name .. " auto mouse")
	end
end


function RMM_Mouse()
	RMM_RightClickFreeLook()
	if rmm_data.Cursor.FreeLook == true then return end
	local moving = IsPlayerMoving()
	local uiactive = IsGameCameraUIModeActive()
	local incombat = IsUnitInCombat("player")
	local inseige = IsPlayerControllingSiegeWeapon()
	if inseige == true then return end
	if incombat == false then
		if moving == false then 
			if uiactive == false then
				if rmm_data.Cursor.Enabled == true then
					zo_callLater(function() SetGameCameraUIMode(true) end, 500)
				end
			end
		end
		if rmm_data.AutoSheathe == true then
			zo_callLater(function() RMM_WeaponSheathe() end, 500)
		end
		if rmm_data.CombatReticleEnabled == true then
			zo_callLater(function() RMM_RET:SetColor(rmm_data.ReticleColor.r,rmm_data.ReticleColor.g,rmm_data.ReticleColor.b) end, 500)
		end
	else
		if rmm_data.CombatReticleEnabled == true then
			RMM_RET:SetColor(rmm_data.CombatReticleColor.r,rmm_data.CombatReticleColor.g,rmm_data.CombatReticleColor.b)
		end
		if rmm_data.AutoSheathe == true then
			rmm_data.WeaponDrawn = true
		end
	end
end

--[[-------- ADDON Initialize, Activate, And Update --------]]--

function RMM_SlashCormmand()
    d("You are using " .. rmm_name .." version " .. rmm_version)
    d("Configuration settings are in the settings interface!")
end

function RMM_Initialize(eventid,addon)
    SLASH_COMMANDS[rmm_cormmand] = RMM_SlashCormmand
    if addon ~= rmm_name then return end
	rmm_data = ZO_SavedVars:NewAccountWide(rmm_saved_data, 5, "Data", rmm_defaults)
	EVENT_MANAGER:UnregisterForEvent(rmm_name,eventid)
    EVENT_MANAGER:RegisterForEvent( rmm_name , EVENT_PLAYER_ACTIVATED , RMM_Activated )
end

function RMM_LoadPanel()
	d("Preparing " .. rmm_name .. " settings")
	if (RMM_Panel == nil) then
		local LAM = LibStub("LibAddonMenu-1.0")
		RMM_Panel = LAM:CreateControlPanel("RMM_Settings" , "|cFF8C00Rive|r Mouse Mod")
		LAM:AddHeader(RMM_Panel, "RMM_GeneralOptions", "General Options")
		LAM:AddCheckbox(RMM_Panel, "RMM_Enabled", "Enable All", "Enable/disable all mouse mods",
				function() return rmm_data.AddonEnabled end,
				function() rmm_data.AddonEnabled = not rmm_data.AddonEnabled end)
		LAM:AddDescription(RMM_Panel, "RMM_EnableDescription", "Controls > Keybingings > General > Rive Mouse Mod", "Keybinding to toggle enabled/disabled in")
		
		LAM:AddHeader(RMM_Panel, "RMM_AutoSheatheOptions", "Auto Sheathe")
		LAM:AddCheckbox(RMM_Panel, "RMM_AutoSheathe", "Enabled", "Sheaths weapon after combat ends",
				function() return rmm_data.AutoSheathe end,
				function() rmm_data.AutoSheathe = not rmm_data.AutoSheathe end)
		
		LAM:AddHeader(RMM_Panel, "RMM_AutoCursorOptions", "Auto Cursor")
		LAM:AddCheckbox(RMM_Panel, "RMM_AutoCursor", "Enabled", "Auto release mouse cursor",
				function() return rmm_data.Cursor.Enabled end,
				function() rmm_data.Cursor.Enabled = not rmm_data.Cursor.Enabled end)
		
		LAM:AddHeader(RMM_Panel, "RMM_ReticleOptions", "Reticle Options")
		LAM:AddSlider(RMM_Panel, "RMM_ReticleSize", "Reticle Scale", "Change the size of the reticle", 0, 4, 1, 
				function() return (rmm_data.ReticleSize - 1) / 0.25 end,
				function(size) rmm_data.ReticleSize = 1 + (size * 0.25)
				RMM_RET:SetScale(rmm_data.ReticleSize) end)
		LAM:AddColorPicker(RMM_Panel, "RMM_ReticleColor", "Reticle Color", "Set the color of the reticle", 
				function() return rmm_data.ReticleColor.r, rmm_data.ReticleColor.g, rmm_data.ReticleColor.b end,
				function(r,g,b,a)
					rmm_data.ReticleColor.r = r
					rmm_data.ReticleColor.g = g
					rmm_data.ReticleColor.b = b
					RMM_RET:SetColor(r,g,b)
				end)
		LAM:AddCheckbox(RMM_Panel, "RMM_CombatReticleEnable", "Combat Reticle", "Enable in combat reticle color",
				function() return rmm_data.CombatReticleEnabled end,
				function() rmm_data.CombatReticleEnabled = not rmm_data.CombatReticleEnabled end)
		LAM:AddColorPicker(RMM_Panel, "RMM_CombatReticleColor", "In Combat Color", "Set the color of the reticle while under attack", 
				function() return rmm_data.CombatReticleColor.r, rmm_data.CombatReticleColor.g, rmm_data.CombatReticleColor.b end,
				function(r,g,b,a)
					rmm_data.CombatReticleColor.r = r
					rmm_data.CombatReticleColor.g = g
					rmm_data.CombatReticleColor.b = b
				end)
		
		local rmm_details = " Author: Tiomun\n Version: " .. rmm_version .. "\n © 2014 All Rights Reserved"
		LAM:AddHeader(RMM_Panel, "RMM_About" , "")
		LAM:AddDescription(RMM_Panel, "RMM_Details", rmm_details, ZO_Options_SectionTitle_WithDivider)
	end
	d(rmm_name .. " settings loaded!")
end
 
function RMM_Activated(eventid)
	RMM_LoadPanel()
	if rmm_data.AddonEnabled == true then
		RMM_RET:SetColor(rmm_data.ReticleColor.r,rmm_data.ReticleColor.g,rmm_data.ReticleColor.b)
		RMM_RET:SetScale(rmm_data.ReticleSize)
	end
	EVENT_MANAGER:RegisterForEvent(rmm_name , EVENT_GLOBAL_MOUSE_DOWN, RMM_MouseDown)
end
 
function RMM_BufferReached(key, buffer)
	if key == nil then return end
	if rmm_buffer_table[key] == nil then rmm_buffer_table[key] = {} end
	rmm_buffer_table[key].buffer = buffer or 3
	rmm_buffer_table[key].now = GetFrameTimeSeconds()
	if rmm_buffer_table[key].last == nil then rmm_buffer_table[key].last = rmm_buffer_table[key].now end
	rmm_buffer_table[key].diff = rmm_buffer_table[key].now - rmm_buffer_table[key].last
	rmm_buffer_table[key].eval = rmm_buffer_table[key].diff >= rmm_buffer_table[key].buffer
	if rmm_buffer_table[key].eval then rmm_buffer_table[key].last = rmm_buffer_table[key].now end
	return rmm_buffer_table[key].eval
end

function RMM_UpdateHandler()
	if not RMM_BufferReached(rmm_name .. "_buffer", 1) then return; end
	if rmm_data.AddonEnabled == false then return end
	-- process update
	RMM_Mouse()
end
   
-- trigger AddOnLoaded function, passes this eventID to function
EVENT_MANAGER:RegisterForEvent( rmm_name , EVENT_ADD_ON_LOADED , RMM_Initialize )
